<?php
/* --------------------------------------------------------------
   dependent.inc.php 2016-12-13
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2016 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

// Add missing japanese country zones
$japanZoneCountryId = $this->query("SELECT countries_id FROM countries WHERE countries_name = 'Japan'");
$japanZoneCountryId = (int)$japanZoneCountryId[0]['countries_id'];

$t_success &= $this->set_index('zones', 'UNIQUE', array('zone_country_id', 'zone_code'), 'unique_country_zone');

if($japanZoneCountryId)
{
	$t_query = "DELETE FROM `zones` WHERE `zone_country_id` = $japanZoneCountryId";
	$t_success &= is_numeric($this->query($t_query));
	
	/* update ISO Codes of japanese prefectures (ISO 3166-2:JP) */
	$query = "INSERT INTO `zones` (`zone_country_id`, `zone_code`, `zone_name`) VALUES
					($japanZoneCountryId, '01', 'Hokkaido'),
					($japanZoneCountryId, '02', 'Aomori'),
					($japanZoneCountryId, '03', 'Iwate'),
					($japanZoneCountryId, '04', 'Miyagi'),
					($japanZoneCountryId, '05', 'Akita'),
					($japanZoneCountryId, '06', 'Yamagata'),
					($japanZoneCountryId, '07', 'Fukushima'),
					($japanZoneCountryId, '08', 'Ibaraki'),
					($japanZoneCountryId, '09', 'Tochigi'),
					($japanZoneCountryId, '10', 'Gunma'),
					($japanZoneCountryId, '11', 'Saitama'),
					($japanZoneCountryId, '12', 'Chiba'),
					($japanZoneCountryId, '13', 'Tokio'),
					($japanZoneCountryId, '14', 'Kanagawa'),
					($japanZoneCountryId, '15', 'Niigata'),
					($japanZoneCountryId, '16', 'Toyama'),
					($japanZoneCountryId, '17', 'Ishikawa'),
					($japanZoneCountryId, '18', 'Fukui'),
					($japanZoneCountryId, '19', 'Yamanashi'),
					($japanZoneCountryId, '20', 'Nagano'),
					($japanZoneCountryId, '21', 'Gifu'),
					($japanZoneCountryId, '22', 'Shizuoka'),
					($japanZoneCountryId, '23', 'Aichi'),
					($japanZoneCountryId, '24', 'Mie'),
					($japanZoneCountryId, '25', 'Shiga'),
					($japanZoneCountryId, '26', 'Kyoto'),
					($japanZoneCountryId, '27', 'Osaka'),
					($japanZoneCountryId, '28', 'Hyogo'),
					($japanZoneCountryId, '29', 'Nara'),
					($japanZoneCountryId, '30', 'Wakayama'),
					($japanZoneCountryId, '31', 'Tottori'),
					($japanZoneCountryId, '32', 'Shimane'),
					($japanZoneCountryId, '33', 'Okayama'),
					($japanZoneCountryId, '34', 'Hiroshima'),
					($japanZoneCountryId, '35', 'Yamaguchi'),
					($japanZoneCountryId, '36', 'Tokushima'),
					($japanZoneCountryId, '37', 'Kagawa'),
					($japanZoneCountryId, '38', 'Ehime'),
					($japanZoneCountryId, '39', 'Kochi'),
					($japanZoneCountryId, '40', 'Fukuoka'),
					($japanZoneCountryId, '41', 'Saga'),
					($japanZoneCountryId, '42', 'Nagasaki'),
					($japanZoneCountryId, '43', 'Kumamoto'),
					($japanZoneCountryId, '44', 'Oita'),
					($japanZoneCountryId, '45', 'Miyazaki'),
					($japanZoneCountryId, '46', 'Kagoshima'),
					($japanZoneCountryId, '47', 'Okinawa')";
	$t_success &= $this->query($query, true);
}

/**
 * set unique index for countries_iso_code_2 and countries_iso_code_3 in countries table
 */
$t_success &= $this->set_index('countries', 'UNIQUE', array('countries_iso_code_2'), 'countries_iso_code_2');
$t_success &= $this->set_index('countries', 'UNIQUE', array('countries_iso_code_3'), 'countries_iso_code_3');

/**
 * Insert the configuration for the mandatory field 'housenumber'
 */
$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "ENTRY_HOUSENUMBER_MIN_LENGTH"', true);
if($check->num_rows === 0)
{
	$query = 'INSERT INTO `configuration` 
				SET configuration_key = "ENTRY_HOUSENUMBER_MIN_LENGTH", 
					configuration_value = "1",
					configuration_group_id = "2",
					sort_order = "5"';
	$t_success &= $this->query($query, true);
}


/**
 * Insert new countries into countries table if they did not exist
 */

$newCountries = array(
	'AX' => array(
		'name' => 'Åland Islands',
		'iso2' => 'AX',
		'iso3' => 'ALA',
		'address_format_id' => '1',
		'status' => '0'
	),
	'BL' => array(
		'name' => 'Saint Barthélemy',
		'iso2' => 'BL',
		'iso3' => 'BLM',
		'address_format_id' => '1',
		'status' => '0'
	),
	'BQ' => array(
		'name' => 'Bonaire, Sint Eustatius and Saba',
		'iso2' => 'BQ',
		'iso3' => 'BES',
		'address_format_id' => '1',
		'status' => '0'
	),
	'CD' => array(
		'name' => 'Congo (the Democratic Republic of the)',
		'iso2' => 'CD',
		'iso3' => 'COD',
		'address_format_id' => '1',
		'status' => '0'
	),
	'CW' => array(
		'name' => 'Curaçao',
		'iso2' => 'CW',
		'iso3' => 'CUW',
		'address_format_id' => '1',
		'status' => '0'
	),
	'GG' => array(
		'name' => 'Guernsey',
		'iso2' => 'GG',
		'iso3' => 'GGY',
		'address_format_id' => '1',
		'status' => '0'
	),
	'IM' => array(
		'name' => 'Isle of Man',
		'iso2' => 'IM',
		'iso3' => 'IMN',
		'address_format_id' => '1',
		'status' => '0'
	),
	'JE' => array(
		'name' => 'Jersey',
		'iso2' => 'JE',
		'iso3' => 'JEY',
		'address_format_id' => '1',
		'status' => '0'
	),
	'ME' => array(
		'name' => 'Montenegro',
		'iso2' => 'ME',
		'iso3' => 'MNE',
		'address_format_id' => '1',
		'status' => '0'
	),
	'MF' => array(
		'name' => 'Saint Martin (French part)',
		'iso2' => 'MF',
		'iso3' => 'MAF',
		'address_format_id' => '1',
		'status' => '0'
	),
	'PS' => array(
		'name' => 'Palestine, State of',
		'iso2' => 'PS',
		'iso3' => 'PSE',
		'address_format_id' => '1',
		'status' => '0'
	),
	'SS' => array(
		'name' => 'South Sudan',
		'iso2' => 'SS',
		'iso3' => 'SSD',
		'address_format_id' => '1',
		'status' => '0'
	),
	'SX' => array(
		'name' => 'Sint Maarten (Dutch part)',
		'iso2' => 'SX',
		'iso3' => 'SXM',
		'address_format_id' => '1',
		'status' => '0'
	),
	'TL' => array(
		'name' => 'Timor-Leste',
		'iso2' => 'TL',
		'iso3' => 'TLS',
		'address_format_id' => '1',
		'status' => '0'
	)
);

foreach($newCountries as $newCountryCode => $newCountry)
{
	$select = 'SELECT * FROM `countries` WHERE `countries_iso_code_2` = "'. $newCountryCode.'"';
	$check = $this->query($select, true);
	if($check->num_rows === 0)
	{
		$query = 'INSERT INTO `countries` 
				  SET `countries_name` = "' . $newCountry['name'] . '",
					  `countries_iso_code_2` = "' . $newCountry['iso2'] . '",
					  `countries_iso_code_3` = "' . $newCountry['iso3'] . '",
					  `address_format_id` = ' . $newCountry['address_format_id'] . ',
					  `status` = ' . $newCountry['status'];
		$t_success &= $this->query($query, true);
	}
}

/**
 * Possibility to switch the verification code for the newsletter on and off
 */
$t_check = $this->query("SELECT * FROM `gm_configuration` WHERE `gm_key` = 'GM_NEWSLETTER_VVCODE'", true);
if($t_check->num_rows === 0)
{
	$t_query = "INSERT INTO `gm_configuration` SET `gm_key` = 'GM_NEWSLETTER_VVCODE', `gm_value` = 'true'";
	$t_success &= (boolean)$this->query($t_query);
}